<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form class="-mb-15px" :model="queryParams" ref="queryFormRef" :inline="true" label-width="90px">
			<el-form-item label="投票活动" prop="votingActivityJoinItemCategory">
				<el-select v-model="queryParams.votingActivityId" filterable placeholder="投票活动" class="!w-240px" @change="handleVotingActivityChange">
					<el-option v-for="item in votingActivityList" :key="item.votingActivityId" :label="item.activityTitle" :value="item.votingActivityId" />
				</el-select>
      </el-form-item>
      <el-form-item label="候选人名称" prop="votingActivityJoinItemTitle">
        <el-input v-model="queryParams.votingActivityJoinItemTitle" placeholder="请输入候选人名称" clearable @keyup.enter="handleQuery" class="!w-240px" />
      </el-form-item>
			<el-form-item label="候选人类型" prop="votingActivityJoinItemCategory">
        <el-input v-model="queryParams.votingActivityJoinItemCategory" placeholder="请输入候选人类型" clearable @keyup.enter="handleQuery" class="!w-240px" />
      </el-form-item>
			<el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button type="primary" plain @click="openForm('create', queryParams.votingActivityId)">
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true">
			<el-table-column label="序号" align="center" prop="num" />
			<el-table-column label="候选人封面" align="center" prop="headImg" width="200">
        <template #default="scope">
          <el-image v-if="scope.row.headImg" class="h-100px w-200px" :initial-index="0" :src="scope.row.headImg" lazy preview-teleported :preview-src-list="[scope.row.headImg]" fit="scale-down" />
        </template>
      </el-table-column>
      <el-table-column label="候选人名称" align="center" prop="votingActivityJoinItemTitle" />
      <el-table-column label="候选人类型" align="center" prop="votingActivityJoinItemCategory" />
      <el-table-column label="票数" align="center" prop="votingActivityJoinItemNum" />
      <el-table-column label="创建时间" align="center" prop="createTime" :formatter="dateFormatter" width="170px" />
      <el-table-column label="操作" align="center" fixed="right" width="170px">
        <template #default="scope">
          <el-button link type="primary" @click="openForm('update', queryParams.votingActivityId, scope.row.votingActivityJoinItemId)">编辑</el-button>
          <el-button link type="danger" @click="handleDelete(scope.row.votingActivityJoinItemId)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <VotingActivityJoinItemForm ref="formRef" :candidate="candidate" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import { VotingActivityApi } from '@/api/menduner/system/vote'
import VotingActivityJoinItemForm from './VotingActivityJoinItemForm.vue'
import { useTagsViewStore } from '@/store/modules/tagsView'
import { ElMessage } from 'element-plus'

/** 专业 列表 */
defineOptions({ name: 'VotingActivityJoinItem' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
	votingActivityId: undefined,
	votingActivityJoinItemTitle: undefined,
	votingActivityJoinItemCategory: undefined,
	createTime: []
})
const queryFormRef = ref() // 搜索的表单

// 候选人列表
const candidate = ref([])
const getCandidateList = async (votingActivityId) => {
  try {
		const data = await VotingActivityApi.getVotingActivityCategories(votingActivityId)
		candidate.value = data
	} catch {}
}

const votingActivityList = ref([])
const getVotingActivityList = async () => {
  try {
		const { list } = await VotingActivityApi.getVotingActivityPage({ pageNo: 1, pageSize: 100 })
		votingActivityList.value = list
	} catch {}
}

/** 查询列表 */
const getList = async () => {
	// 候选人列表
	getCandidateList(queryParams.votingActivityId)
  loading.value = true
  try {
    const data = await VotingActivityApi.getVotingActivityJoinItemPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

const handleVotingActivityChange = () => {
	queryParams.pageNo = 1
	getList()
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, votingActivityId: number, votingActivityJoinItemId?: number) => {
  formRef.value.open(type, votingActivityId, votingActivityJoinItemId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await VotingActivityApi.deleteVotingActivityJoinItem(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 */
const { currentRoute } = useRouter() // 路由
const { delView } = useTagsViewStore() // 视图操作
const route = useRoute()
const { id } = route.params
onMounted(() => {
  if (!id) {
    ElMessage.warning('参数错误，投票活动id不能为空！')
    delView(unref(currentRoute))
    return
  }
  queryParams.votingActivityId = id
  getList()
	getVotingActivityList()
})
</script>